//
// Generated by Microsoft (R) D3DX9 Shader Compiler 9.08.299.0000
//
//   vsa shaderdump19/HDR004.pso /Fcshaderdump19/HDR004.pso.dis
//
//
#define	ScreenSpace	Src0
// Parameters:
//
sampler2D AvgLum : register(s2);
sampler2D DestBlend : register(s1);
float4 HDRParam : register(c1);
sampler2D ScreenSpace : register(s0);

float4 TESR_ToneMapping : register(c63);

//
//	SetPixelShaderConstantF[0+]				[BlurShaderHDR]
//		|0.000000|0.000000|0.000000|0.000000|           fTargetLUM=1.2000
//	SetPixelShaderConstantF[1+]                             fUpperLUMClamp=1.4000
//		|1.200000|1.350000|0.500000|1.400000|           fGrassDimmer=1.3000
//	SetPixelShaderConstantF[2+]                             fTreeDimmer=1.2000
//		|0.000000|0.003906|0.000000|0.000000|           fEmissiveHDRMult=2.0000
//	SetPixelShaderConstantF[3+]                             fEyeAdaptSpeed=0.7000
//		|-7.000000|-7.000000|0.000000|0.000000|         fSunlightDimmer=1.3000
//		|-6.000000|-6.000000|0.000000|0.000000|         fSIEmmisiveMult=1.0000
//		|-5.000000|-5.000000|0.000000|0.000000|         fSISpecularMult=1.5000
//		|-4.000000|-4.000000|0.000000|0.000000|         fSkyBrightness=0.5000
//		|-3.000000|-3.000000|0.000000|0.000000|         fSunBrightness=0.0000
//		|-2.000000|-2.000000|0.000000|0.000000|         fBrightScale=1.5000
//		|-1.000000|-1.000000|0.106507|0.000000|         fBrightClamp=1.3500
//		|0.000000|0.000000|0.786986|0.000000|           fBlurRadius=1.0000
//		|1.000000|1.000000|0.106507|0.000000|           iNumBlurpasses=1
//		|2.000000|2.000000|0.000000|0.000000|           iBlendType=2
//		|3.000000|3.000000|0.000000|0.000000|           bDoHighDynamicRange=1
//		|4.000000|4.000000|0.000000|0.000000|
//		|5.000000|5.000000|0.000000|0.000000|
//		|6.000000|6.000000|0.000000|0.000000|
//		|7.000000|7.000000|0.000000|0.000000|
//		|0.000000|0.000000|0.000000|0.000000|
//
// Registers:
//
//   Name         Reg   Size
//   ------------ ----- ----
//   HDRParam     const_1       1
//   ScreenSpace         texture_0       1
//   DestBlend    texture_1       1
//   AvgLum       texture_2       1
//

#include "Includes/Color.hlsl"

// Structures:

struct VS_OUTPUT {
    float2 ScreenOffset : TEXCOORD0;
    float2 texcoord_1 : TEXCOORD1;
};

struct PS_OUTPUT {
    float4 color_0 : COLOR0;
};

float rand_1_10(in float2 uv)
{
	float2 noise = (frac(sin(dot(uv ,float2(12.9898,78.233)*2.0)) * 43758.5453));
	return frac(noise.x + noise.y) * 2.0 - 1.0;
}

// Code:

PS_OUTPUT main(VS_OUTPUT IN) {
    PS_OUTPUT OUT;

#define	weight(v)		dot(v, 1)

    float3 reslt;
    float3 color;
    float3 avlum;
    float3 blurc;
    float rwhite;
    float whitep, whitef;
    float luma, lumc, amplify;

    blurc = tex2D(ScreenSpace, IN.ScreenOffset.xy).rgb;
    color = tex2D(DestBlend, IN.texcoord_1.xy).rgb;
    avlum = tex2D(AvgLum, IN.ScreenOffset.xy).rgb;
    avlum = max(0.05, avlum);

    rwhite = 1.0 / max(weight(avlum), HDRParam.x); // 1.0 / max(range, fTargetLUM)
    reslt = ((rwhite * HDRParam.x) * color) + max(blurc * (rwhite * 0.5), 0);

    luma = GetLuminance(avlum);
    lumc = GetLuminance(color);

    /* eye-adaption */
    whitep = HDRParam.x;
    whitef = whitep / max(luma, whitep /*- 0.125*/);
//  whitef = pow(whitep, 0.125 / luma);
//  whitef = GetIntensity(r2.xyz);
//  whitef = log(2 + whitef) / log(2 + whitep);

    /* whitepoint-based eye-adaption */
    blurc = blurc * (whitef * GetWhitePoint() * TESR_ToneMapping.y);
    color = color * (whitef * GetWhitePoint() * TESR_ToneMapping.z);

    /* final color (color + blur) */
    reslt = (blurc) + (color);

    luma = GetLuminance(avlum);
    lumc = GetLuminance(reslt);

    /* logarithmic tonemapper (average luminance vs. pixel luminance) */
    amplify = log(2.2 + 4.2 * luma + TESR_ToneMapping.x + min(lumc * 64.0, (0.001 / pow(luma, 2.2)))) / log(2.2 + 4.2 * luma + TESR_ToneMapping.x + lumc);
    reslt *= amplify;

    luma = GetLuminance(avlum);
    lumc = GetLuminance(reslt);

    /* night blue-shift */
    reslt = lerp(lerp(BlueShift / 32, reslt * BlueShift / length(BlueShift), saturate(sqrt(luma) * 2)), reslt, saturate(sqrt(lumc) * 2));

    /* rod-grain */
//  reslt = reslt - (saturate(0.05 - luma) * rand_1_10(IN.ScreenOffset.xy * float2(lumc, luma)));

    OUT.color_0.a = 1;
    OUT.color_0.rgb = reslt;

    return OUT;
};

// approximately 13 instruction slots used (3 texture, 10 arithmetic)